#include "Unix.h"
  //#include <iostream.h>
  //#include <fstream.h>
  //filebuf miti_file_buf;
  //istream stream(&miti_file_buf);

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wwrite-strings"
#pragma GCC diagnostic ignored "-Wmisleading-indentation"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-parameter"

#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wsign-compare"
#pragma GCC diagnostic ignored "-Wformat="

char namef[260], ProgramPath[260]; // _MAX_PATH
MY_INT ServersCount, file;
CProjectInfo *pInfo2, DefaultProject;
char **arguments;
MY_INT numberArgs;

int main( int argc , char *argv[ ] , char *envp[ ]  )
{
  MY_INT i, k=2;
  numberArgs = argc;
  arguments = argv;

#if UNIX_TR
  printf("content-type:text/html\r\n\r\n");
#endif

  if (argc < 2)
  {
#if PROF==2
    printf("\r\n\r\nStrawberry Prolog - version 5.1\r\n");
#else
    printf("\r\n\r\nStrawberry Prolog - version 5.1\r\nLight Edition (freeware)\r\n\r\n");
#endif
    printf("This program is property of \"AE - Dimiter Dobrev\"\r\n");
    printf("All rights reserved.\r\n\r\n");
    printf("Usage: strawberry file.pro \r\n\r\n");
    exit(1);
  }
  pInfo2=&DefaultProject;
  DefaultProject.m_Settings=1;
  DefaultProject.STACK_start=2000;           // the minimum is 8
  DefaultProject.BUDA_start=MAX_VARS+2048;   // this is the minimum
  DefaultProject.BUDA_S_start=MAX_VARS+4096; // this is the minimum
  STACK2=DefaultProject.STACK_start-8;
  BUDA3=DefaultProject.BUDA_start-MAX_VARS;
  BUDA_S2=DefaultProject.BUDA_S_start-MAX_VARS;
  DefaultProject.STACK_max=64000;
  DefaultProject.BUDA_max=0x100000;
  DefaultProject.BUDA_S_max=0x100000;
  strcpy(ProgramPath, argv[0]);
  for(i=strlen(ProgramPath); i>0 && ProgramPath[i-1]!='\\' && ProgramPath[i-1]!=':'; i--);
  ProgramPath[i]=0;
  strcpy(namef, argv[1]);
  
  MitiGlobalAlloc();
  compile(0);
#if DUMP
  dump_br=0;
  if (all_dumps[0]==0)
  {
    make_dump(0);
    dump_br++;
  }
#endif

  status_fl=2; // running
  if (error==0)
    k=call(0, 0);
#if UNIX_TR==0
  if (k!=1)
  {
    printf("content-type:text/html\r\n\r\n");
    printf("\r\n\r\nStrawberry Prolog - version 5.1\r\n");
    printf("This program is property of \"AE - Dimiter Dobrev\"\r\n");
    printf("All rights reserved.\r\n");
#else
  if (k>1)
  {
#endif
    printf("\r\nCompiling the file:\r\n%s\r\n", namef);
    printf("%d error%s, %d warning%s.\r\n", 
            (int)error, (error==1)?"":"s", (int)warn_br, (warn_br==1)?"":"s");
#if UNIX_TR==0
    printf("\r\nSomething wrong! Return=%d\r\n", (int)k);
  }
#else
  }
  else if (k==1)
    printf("Yes.\r\n");
  else
    printf("No.\r\n");
  printf("\r\nsteps=%lld\r\n", (MY_LONG)(0x10000*lSteps_br+Steps_br-Correction));
#endif
  //scanf("%d", &i);
  return(1);
}

void GlobalFree(MY_HANDLE hMem)
{
  free(hMem);
  return;
}
MY_HANDLE GlobalLock(MY_HANDLE handle)
{
  return(handle);
}
void MessageBox(MY_INT null, char *Title, char *Message, MY_INT Ok)
{
}
//#if !UNIX
//void __cdecl MessageBoxA(MY_INT null, char *Title, char *Message, MY_INT Ok)
//{
//}
//#endif

#if UNIX

#include "Assert.cpp"
#include "Call.cpp"
#include "Creat.cpp"
#include "Execute.cpp"
#include "Global.cpp"
#include "Intelig.cpp"
#include "Read.cpp"
#include "Register.cpp"
#include "Unregister.cpp"
#include "Write.cpp"

#endif

#pragma GCC diagnostic pop
